Status: Resolved Priority: Should have
Author: Kobbe van Daatselaar Category: Object
Created: 2012-07-16 Assigned To: Karsten Dambekalns
Updated: 2012-12-12 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: FLOW3 1.1.0 rc 1
Subject: Wrong arguments check in buildConstructorInjectionCode (class 

TYPO3\FLOW3\Object\DependencyInjection\ProxyClassBuilder)
Description

On line 370 there is a wrong check on the constructor arguments.
The current code doesn't allow a NULL value to be send to a class contructor.
The isset() check should be replaced by an array_key_exists check:

if ($objectConfiguration->getScope() === \TYPO3\FLOW3\Object\Configuration\Configuration::SCOPE_SINGLETON) {
                $code .= '        if (!array_key_exists(' . $index . ', $arguments)) throw new
\TYPO3\FLOW3\Object\Exception\UnresolvedDependenciesException(\'Missing required constructor argument $' .
$parameterName . ' in class \' . __CLASS__ . \'. ' . 'Please check your calling code and Dependency Injection configuration.\',
1296143787);' . "\n";
                //$code .= '        if (!isset($arguments[' . $index . '])) throw new
\TYPO3\FLOW3\Object\Exception\UnresolvedDependenciesException(\'Missing required constructor argument $' .
$parameterName . ' in class \' . __CLASS__ . \'. ' . 'Please check your calling code and Dependency Injection configuration.\',
1296143787);' . "\n";
            } else {
                $code .= '        if (!array_key_exists(' . $index . ', $arguments)) throw new
\TYPO3\FLOW3\Object\Exception\UnresolvedDependenciesException(\'Missing required constructor argument $' .
$parameterName . ' in class \' . __CLASS__ . \'. ' . 'Note that constructor injection is only support for objects of scope singleton
(and this is not a singleton) â€“ for other scopes you must pass each required argument to the constructor yourself.\',
1296143788);' . "\n";
                //$code .= '        if (!isset($arguments[' . $index . '])) throw new
\TYPO3\FLOW3\Object\Exception\UnresolvedDependenciesException(\'Missing required constructor argument $' .
$parameterName . ' in class \' . __CLASS__ . \'. ' . 'Note that constructor injection is only support for objects of scope singleton
(and this is not a singleton) â€“ for other scopes you must pass each required argument to the constructor yourself.\',
1296143788);' . "\n";
            }

Associated revisions
Revision 798d2b32 - 2012-12-03 15:31 - Karsten Dambekalns

[BUGFIX] Fix arguments check in buildConstructorInjectionCode, allow NULL

It was not possible to pass NULL as constructor arguments, because of
the use of isset() instead of array_key_exists().

Also a few other places needed to be changed and some tiny (unrelated)
tweaks were made.
Change-Id: I7470ff1a38a3b1ee9afc5771ab971478b59538e6
Fixes: #38988
Releases: 1.2

History
#1 - 2012-07-19 09:28 - Karsten Dambekalns
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns

#2 - 2012-07-19 09:29 - Karsten Dambekalns
- Category set to Object
- Has patch set to No

#3 - 2012-07-25 18:12 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13047

#4 - 2012-07-25 18:13 - Karsten Dambekalns
- Target version set to 1.1

#5 - 2012-07-25 18:43 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13047

#6 - 2012-08-17 11:19 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1.1

#7 - 2012-12-03 15:48 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13047

#8 - 2012-12-11 10:38 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/17094

#9 - 2012-12-12 22:12 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:798d2b324dd420c64cfbfad6359befdadbb59f45.
